//
//  ViewController.m
//  MapTestFinal
//
//  Created by Alex on 9/7/12.
//  Copyright (c) 2012 Alex. All rights reserved.
//

#import "ViewController.h"
#import "PolylineAnnotationView.h"
#import "MapPin.h"
#import <MapKit/MapKit.h>




@implementation ViewController
@synthesize btnPopupInformation = _btnPopupInformation;
@synthesize btnPopupCancel = _btnPopupCancel;
@synthesize scrPopupBig = _scrPopupBig;
@synthesize scrPopupSmall = _scrPopupSmall;
@synthesize textOne = _textOne;
@synthesize textTwo = _textTwo;
@synthesize textThree = _textThree;
@synthesize textFour = _textFour;



- (void)loadView {
	[super loadView];
	
	_mapView = [[MKMapView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)];
	[_mapView setDelegate:self];
	[self.view addSubview:_mapView];

    NSArray *points = [NSArray arrayWithObjects:
                       [[CLLocation alloc] initWithLatitude:46.908457 longitude:-96.80676],
                       [[CLLocation alloc] initWithLatitude:46.908457 longitude:-96.803144],
                       [[CLLocation alloc] initWithLatitude:46.904704 longitude:-96.803155],
                       [[CLLocation alloc] initWithLatitude:46.904279 longitude:-96.80279],
                       [[CLLocation alloc] initWithLatitude:46.893723 longitude:-96.802769],
                       nil];
    

	PolylineAnnotation *annotation = [[PolylineAnnotation alloc] initWithPoints:points mapView:_mapView];
	[_mapView addAnnotation:annotation];
    
    MKCoordinateRegion myriad;
    myriad.span.longitudeDelta = .1;
    myriad.span.latitudeDelta = .1;
    myriad.center.latitude = 46.904279;
    myriad.center.longitude = -96.8027;
    [_mapView setRegion:myriad animated:YES];


    
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation {
    
	if ([annotation isKindOfClass:[PolylineAnnotation class]]) {
		return [[PolylineAnnotationView alloc] initWithAnnotation:annotation mapView:_mapView];
	}
	return nil;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    


    MKCoordinateRegion myriad;
    myriad.center.latitude = 46.908457;
    myriad.center.longitude = -96.80676;
    
    MapPin *pin = [[MapPin alloc] init];
    pin.title = @"Myriad";
    pin.subTitle = @"Office";
    pin.coordinate = myriad.center;
    [_mapView addAnnotation:pin];
    
    
    MKCoordinateRegion iacc;
    iacc.center.latitude = 46.89362;
    iacc.center.longitude = -96.803348;
    
    MapPin *pin2 = [[MapPin alloc] init];
    pin2.title = @"IACC";
    pin2.subTitle = @"Building";
    pin2.coordinate = iacc.center;
    [_mapView addAnnotation:pin2];

    
    
}

-(void)mapView:(MKMapView *)mapView didSelectAnnotationView:(MKAnnotationView *)view
{
/*    NSString* locationTitle = [view.annotation title];
    NSString* locationSubTitle = [view.annotation subtitle];*/
    
    
    NSArray * views = [[NSBundle mainBundle] loadNibNamed:@"MapPopup" owner:nil options:nil];
    for (int i = 0; i < [views count]; i++)
    {
        if([[views objectAtIndex:i] tag] == 9999)
        {
            _scrPopupBig = [views objectAtIndex:i];
            
            _scrPopupSmall = [_scrPopupBig viewWithTag:10001];
            
            _btnPopupInformation = [_scrPopupSmall viewWithTag:10002];
            
            _btnPopupCancel = [_scrPopupSmall viewWithTag:10003];
            /*
            
            _textOne = [_scrPopupBig viewWithTag:1000042];
            _textTwo = [_scrPopupBig viewWithTag:100005];
            [_textOne setText:locationTitle];
            [_textTwo setText:locationSubTitle];*/
        }
        
    }
    
    [self.view addSubview:_scrPopupBig];
    [_btnPopupCancel addTarget:self action:@selector(closePopup) forControlEvents:UIControlEventTouchUpInside];
    [_btnPopupInformation addTarget:self action:@selector(informationPopup) forControlEvents:UIControlEventTouchUpInside];
    
    CGRect originalFrame = [_scrPopupSmall frame];
    
    [_scrPopupSmall setFrame:CGRectMake(originalFrame.origin.x, originalFrame.origin.y + 400, originalFrame.size.width, originalFrame.size.height)];
    [UIView beginAnimations:@"MoveIn" context:nil];
    [_scrPopupSmall setFrame:originalFrame];
    [UIView commitAnimations];

    
}

-(void)removePopup{
    if (_scrPopupBig)
    {
        [_scrPopupBig removeFromSuperview];
    }
}
    

-(void)closePopup
{
    [UIView beginAnimations:@"MoveOut" context:nil];
    [_scrPopupSmall setFrame:CGRectMake(_scrPopupSmall.frame.origin.x, _scrPopupSmall.frame.origin.y + 400, _scrPopupSmall.frame.size.width, _scrPopupSmall.frame.size.height)];
    
    [UIView setAnimationDelegate:self];
    [UIView setAnimationDidStopSelector:@selector(removePopup)];
    [UIView commitAnimations];
}
    
- (void)viewDidUnload
{
    [self setBtnPopupInformation:nil];
    [self setBtnPopupCancel:nil];
    [self setScrPopupBig:nil];
    [self setScrPopupSmall:nil];
    [self setTextOne:nil];
    [self setTextTwo:nil];
    [self setTextThree:nil];
    [self setTextFour:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}


@end
